Description

In the watcher section of an issue's sidebar, the order of watchers is not explicitly specified and is environment-dependent (see

watcher_users below).

I would suggest improving `watcher_users` to ensure that watchers are displayed in the order they are added.

lib/plugins/acts_as_watchable/lib/acts_as_watchable.rb:

      module ClassMethods

        def acts_as_watchable(options = {})

          return if self.included_modules.include?(Redmine::Acts::Watchable::InstanceMethods)

          class_eval do

            has_many :watchers, :as => :watchable, :dependent => :delete_all

            has_many :watcher_users, :through => :watchers, :source => :user, :validate => false

Related issues:

Has duplicate Redmine - Feature #19484: Users ordering Closed

Associated revisions

Revision 22224 - 2023-05-05 05:49 - Go MAEDA

Display order of watchers in the sidebar is indeterminate (#38458).

Patch by Holger Just.

Revision 22225 - 2023-05-05 05:50 - Go MAEDA

Add test for r22224 (#38458).

History

#1 - 2023-04-17 08:48 - Go MAEDA

- Description updated

#2 - 2023-04-17 14:14 - Holger Just

How about ordering it alphabetically (or more specifically: sorted according to the chosen name formatting)? That way, long watcher lists would be

easy to scan, we would not leak possible meta data about watchers, and the patch is small :)

This change could probably be implemented by this patch only:

diff --git a/app/helpers/watchers_helper.rb b/app/helpers/watchers_helper.rb

index dfd3d5c490..d8a1e07759 100644

--- a/app/helpers/watchers_helper.rb

+++ b/app/helpers/watchers_helper.rb

@@ -48,7 +48,7 @@ def watcher_css(objects)

   def watchers_list(object)

     remove_allowed = User.current.allowed_to?("delete_#{object.class.name.underscore}_watchers".to_sym, objec

t.project)

     content = ''.html_safe

-    lis = object.watcher_users.collect do |user|

+    lis = object.watcher_users.sorted.collect do |user|

       s = ''.html_safe

       s << avatar(user, :size => "16").to_s
       s << link_to_principal(user, class: user.class.to_s.downcase)

#3 - 2023-04-17 15:02 - Go MAEDA

I agree with your idea of sorting watchers by their names.

The reason I suggested displaying watchers in the order they were added is that watchers are currently often displayed in this order.

But now I think sorting watchers by their name is better than the order they are added. It is intuitive and the order of addition is not so important in

ordinary situations.

#4 - 2023-05-01 08:47 - Go MAEDA

- File test-for-38458-note-2.patch added

- Subject changed from Undefined display order of watchers in the sidebar to Display order of watchers in the sidebar is indeterminate

- Target version set to 5.1.0

Setting the target version to 5.1.0.

#5 - 2023-05-01 08:51 - Go MAEDA

- File deleted (test-for-38458-note-2.patch)

#6 - 2023-05-01 08:51 - Go MAEDA

- File test-for-38458-note-2.patch added

#7 - 2023-05-05 05:51 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22225.

#8 - 2024-02-05 11:21 - Holger Just

- Has duplicate Feature #19484: Users ordering added

Files

test-for-38458-note-2.patch 2.33 KB 2023-05-01 Go MAEDA
